module Tomte::Protocol
  module Dialog
    class Server < Tomte::Protocol::Consumer

      #Response = Struct.new(:payload, :options, :additional_headers)

      class Response

        attr_accessor :payload
        attr_accessor :options
        attr_accessor :additional_headers

        # if this is false, response is NOT valid, and won't be sent back
        attr_accessor :valid

        def initialize(payload = nil, options = {}, additional_headers = {})
          @payload, @options, @additional_headers = payload, options, additional_headers
          @valid = true
        end

        def valid?
          @valid
        end

        def invalidate!
          @valid = false
        end
      end
    end
  end
end
