
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.


module Tomte
module Protocol

  module Endpoint

    autoload :Async,            'tomte/protocol/endpoint/async'
    autoload :Sync,             'tomte/protocol/endpoint/sync'
    autoload :Adapter,          'tomte/protocol/endpoint/adapter'

    autoload :Entities,         'tomte/protocol/endpoint/entities'

    #
    # makes it easier to get an endpoint
    #
    def self.new(options = {})

      options[:sync] ?
        Endpoint::Sync.new(options) :
        Endpoint::Async.new(options)
    end

    #
    # Gives you a sync endpoint out of an async one.
    # All endpoints are internally async. So you can get the underlying async ep out of a sync
    # one by doing sync_endpoint.async
    #
    def self.synchronize(async_endpoint)
      Endpoint::Sync.new(:async_endpoint => async_endpoint)
    end

  end
end
end
