
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol

  module Enveloper


    module Queue
      extend ActiveSupport::Concern

      included do
        include Hooks
        attr_accessor :enveloper
      end

      module ClassMethods
        def consumer_class
          Tomte::Protocol::Consumer
        end
      end


      def initialize(channel, name = AMQ::Protocol::EMPTY_STRING, options = {}, &block)
        super
        @enveloper = (options && options.delete(:enveloper)) || @channel.enveloper
      end


      def pop(opts = {}, &block)
        shim = Proc.new { | headers, payload, consumer_tag, delivery_tag, redelivered, exchange, routing_key |

                 data = envelope_wire_to_local(payload, headers,
                                               :consumer_tag => consumer_tag,
                                               :delivery_tag => delivery_tag,
                                               :redelivered => redelivered,
                                               :exchange => exchange,
                                               :routing_key => routing_key)

                 case block.arity
                 when 1 then
                   block.call(data.message)
                 when 2 then
                   block.call(data.metadata, data.message)
                 else
                   block.call(data.metadata, data.message, consumer_tag,
                              delivery_tag, redelivered, exchange, routing_key)
                 end
               }
        super(&shim)
      end

    end
  end
end
