# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol
  class Queue < AMQP::Queue

    #include Enveloper::Queue

    attr_reader :channel

    def initialize(channel, name = AMQ::Protocol::EMPTY_STRING, opts = {}, &block)
      super
      # sort of a monkeypatch, for a bug in the AMQP library
      # nowait is handled as a persistent property of the exchange
      # while should be local to the method, so, don't keep it
      #
      @opts.delete(:nowait)
    end

    private
    #######

    #
    # used by Queue#publish to return the associated exchange, we just override it here
    # so it will return a Tomte::Exchange
    #
    def exchange
      @exchange ||= Exchange.new(@channel, :direct, AMQ::Protocol::EMPTY_STRING, :key => name)
    end

    # @return [Class]
    # @private
    def self.consumer_class
      Tomte::Protocol::Async::Consumer
    end # self.consumer_class

  end


end