
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol::Sync::Dialog
  class Server
    extend Forwardable
    include Tomte::Protocol::Synchronization
    include Tomte::Protocol::Sync::Entity

    attr_reader :entity

    def_delegators :@entity, :on_call

    def initialize(connection, options = {})

      initialize_from_async_entity connection
      @entity ||= Tomte::Protocol::Dialog::Server.new(connection, options)
    end

    def consume
      resync do |wc|
        @entity.consume { wc.return }
      end
    end

  end
end