
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol::Sync
  class Producer
    include Tomte::Protocol::Synchronization
    include Tomte::Protocol::Sync::Entity

    attr_reader :entity

    def initialize(connection, options = {})

      initialize_from_async_entity connection
      @entity ||= Tomte::Protocol::Producer.new(connection, options)
    end

    def publish(payload, options = {})
      resync do |wc|

        errback = proc { |exception| wc.return_raise exception }

        @entity.publish(payload, {:errback => errback}.merge(options)) do |response|
          wc.return response
        end
      end
    end

  end
end
